if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFAMissions = {}
local this = ttd2.BFAMissions

this.name = "BFAMissions"

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.missions = {}	
	local missions = this.private.missions
	missions[1885] = {AchievementID = 12896, CriteriaID = 41140}
	missions[1886] = {AchievementID = 12896, CriteriaID = 41141}
	missions[1890] = {AchievementID = 12896, CriteriaID = 41139}
	missions[1891] = {AchievementID = 12896, CriteriaID = 41142}
	missions[1896] = {AchievementID = 12896, CriteriaID = 41143}
	missions[1897] = {AchievementID = 12896, CriteriaID = 41144}
	missions[1898] = {AchievementID = 12896, CriteriaID = 41145}
	missions[1899] = {AchievementID = 12896, CriteriaID = 41146}
	missions[1905] = {AchievementID = 12896, CriteriaID = 41147}
	missions[1906] = {AchievementID = 12896, CriteriaID = 41148}
	missions[1913] = {AchievementID = 12896, CriteriaID = 41149}
	missions[1917] = {AchievementID = 12896, CriteriaID = 41150}
	missions[1918] = {AchievementID = 12896, CriteriaID = 41151}
	
	missions[1883] = {AchievementID = 12898, CriteriaID = 41176}
	missions[1884] = {AchievementID = 12898, CriteriaID = 41177}
	missions[1888] = {AchievementID = 12898, CriteriaID = 41178}
	missions[1889] = {AchievementID = 12898, CriteriaID = 41179}
	missions[1894] = {AchievementID = 12898, CriteriaID = 41180}
	missions[1895] = {AchievementID = 12898, CriteriaID = 41181}
	missions[1903] = {AchievementID = 12898, CriteriaID = 41182}
	missions[1904] = {AchievementID = 12898, CriteriaID = 41183}
	missions[1909] = {AchievementID = 12898, CriteriaID = 41184}
	missions[1911] = {AchievementID = 12898, CriteriaID = 41185}
	missions[1912] = {AchievementID = 12898, CriteriaID = 41186}
	missions[1914] = {AchievementID = 12898, CriteriaID = 41187}
	missions[1915] = {AchievementID = 12898, CriteriaID = 41188}
	
	missions[1858] = {AchievementID = 12899, CriteriaID = 41189}
	missions[1866] = {AchievementID = 12899, CriteriaID = 41190}
	missions[1882] = {AchievementID = 12899, CriteriaID = 41191}
	missions[1887] = {AchievementID = 12899, CriteriaID = 41192}
	missions[1892] = {AchievementID = 12899, CriteriaID = 41193}
	missions[1893] = {AchievementID = 12899, CriteriaID = 41194}
	missions[1900] = {AchievementID = 12899, CriteriaID = 41195}
	missions[1901] = {AchievementID = 12899, CriteriaID = 41196}
	missions[1902] = {AchievementID = 12899, CriteriaID = 41197}
	missions[1907] = {AchievementID = 12899, CriteriaID = 41198}
	missions[1908] = {AchievementID = 12899, CriteriaID = 41199}
	missions[1910] = {AchievementID = 12899, CriteriaID = 41200}
	missions[1916] = {AchievementID = 12899, CriteriaID = 41201}
	
	missions[1929] = {AchievementID = 12867, CriteriaID = 41096}
	missions[1923] = {AchievementID = 12867, CriteriaID = 41097}
	missions[1934] = {AchievementID = 12867, CriteriaID = 41098}
	missions[1935] = {AchievementID = 12867, CriteriaID = 41099}
	missions[1879] = {AchievementID = 12867, CriteriaID = 41100}
	missions[1959] = {AchievementID = 12867, CriteriaID = 41101}
	missions[1937] = {AchievementID = 12867, CriteriaID = 41102}
	missions[1936] = {AchievementID = 12867, CriteriaID = 41103}
	missions[1943] = {AchievementID = 12867, CriteriaID = 41104}
	missions[1951] = {AchievementID = 12867, CriteriaID = 41105}
	missions[1944] = {AchievementID = 12867, CriteriaID = 41106}
	missions[1955] = {AchievementID = 12867, CriteriaID = 41107}
	missions[1956] = {AchievementID = 12867, CriteriaID = 41108}
	
	missions[1921] = {AchievementID = 12869, CriteriaID = 41163}
	missions[1922] = {AchievementID = 12869, CriteriaID = 41164}
	missions[1927] = {AchievementID = 12869, CriteriaID = 41165}
	missions[1928] = {AchievementID = 12869, CriteriaID = 41166}
	missions[1932] = {AchievementID = 12869, CriteriaID = 41167}
	missions[1933] = {AchievementID = 12869, CriteriaID = 41168}
	missions[1941] = {AchievementID = 12869, CriteriaID = 41169}
	missions[1942] = {AchievementID = 12869, CriteriaID = 41170}
	missions[1946] = {AchievementID = 12869, CriteriaID = 41171}
	missions[1949] = {AchievementID = 12869, CriteriaID = 41172}
	missions[1950] = {AchievementID = 12869, CriteriaID = 41173}
	missions[1952] = {AchievementID = 12869, CriteriaID = 41174}
	missions[1953] = {AchievementID = 12869, CriteriaID = 41175}
	
	missions[1919] = {AchievementID = 12870, CriteriaID = 41202}
	missions[1920] = {AchievementID = 12870, CriteriaID = 41203}
	missions[1925] = {AchievementID = 12870, CriteriaID = 41204}
	missions[1926] = {AchievementID = 12870, CriteriaID = 41205}
	missions[1930] = {AchievementID = 12870, CriteriaID = 41206}
	missions[1931] = {AchievementID = 12870, CriteriaID = 41207}
	missions[1938] = {AchievementID = 12870, CriteriaID = 41208}
	missions[1939] = {AchievementID = 12870, CriteriaID = 41209}
	missions[1940] = {AchievementID = 12870, CriteriaID = 41210}
	missions[1945] = {AchievementID = 12870, CriteriaID = 41211}
	missions[1947] = {AchievementID = 12870, CriteriaID = 41212}
	missions[1948] = {AchievementID = 12870, CriteriaID = 41213}
	missions[1954] = {AchievementID = 12870, CriteriaID = 41214}
	
	local faction = UnitFactionGroup("player")
	this.private.achievementIDs = {}
	if(faction == "Alliance") then
		this.private.achievementIDs[1] = 12896
		this.private.achievementIDs[2] = 12898
		this.private.achievementIDs[3] = 12899
	else
		this.private.achievementIDs[1] = 12867
		this.private.achievementIDs[2] = 12869
		this.private.achievementIDs[3] = 12870
	end
		
	this.private.outputReady = false
	
	this.private.set = true
end

function this.private.ListAchievements()
	this.private.Validate()
	
	local out = lib.chat.output
	
	for _,ID in pairs(this.private.achievementIDs) do
		local complete = select(13,GetAchievementInfo(ID))
		if(complete) then
			out.StoreCompleted(GetAchievementLink(ID))
		else
			out.StoreTodo(GetAchievementLink(ID))
		end
	end
	
	return
end

function this.private.ListMissions()
	this.private.Validate()
	
	local out = lib.chat.output	
	local missions = C_Garrison.GetAvailableMissions(LE_FOLLOWER_TYPE_GARRISON_8_0)
	
	if(missions == nil) then
		out.StoreTodo(this.name..": not unlocked on this character.")
		return
	end
	
	if(#missions == 0) then
		out.StoreDone(this.name..": no missions available.")
		return
	end
	
	for _,mission in pairs(missions) do
		if(this.private.missions[mission.missionID] == nil) then
			out.StoreDone(mission.name.." (not part of any achievement)")
		else
			local _,_,completed = GetAchievementCriteriaInfoByID(
				this.private.missions[mission.missionID].AchievementID,
				this.private.missions[mission.missionID].CriteriaID)
		
			if(completed) then
				out.StoreCompleted(mission.name.." << "..GetAchievementLink(this.private.missions[mission.missionID].AchievementID))
			else
				out.StoreTodo(mission.name.." << "..GetAchievementLink(this.private.missions[mission.missionID].AchievementID).." << expires in: "..mission.offerTimeRemaining)
			end
		end
	end
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	lib.chat.output.ClearBuffer()
	--this.private.ListAchievements()	
	this.private.ListMissions()	
	return
end

function this.private.Print()
	this.private.Validate()
	
	local out = lib.chat.output
	out.PrintModule(this.name)
	return
end

this.private.Text = this.name
function this.private.Script()
	this.private.Validate()
	
	this.private.Update()
	this.private.Print()
	
	return
end

mod[#mod+1] = {
	Text = this.private.Text,
	Script = this.private.Script
}
